Framework BRL.D3D7Max2D
Import BRL.Random
Import BRL.PNGLoader
SetGraphicsDriver D3D7Max2DDriver:TD3D7Max2DDriver() 


'Framework BRL.GLMax2D
'Import BRL.Random
'Import BRL.PNGLoader
'SetGraphicsDriver GLMax2DDriver:TGLMax2DDriver()

SeedRnd MilliSecs()


AppTitle = "D-Viruzz 8192b"

Graphics 640 , 480 , 0 , 60

DrawText"FULLSCREEN Y/N" , 9 , 9
Flip

Repeat
	If KeyHit(KEY_N) a=1
	If KeyHit(KEY_Y) a=2
Until a>0
	
If a = 2
	Graphics 640,480,32,30
EndIf

Global ACTIVE_PLAYER = 0
Global PLAYER1_STONES = 0
Global PLAYER2_STONES = 0

SetMaskColor 255,0,255
HideMouse()

Global G_BACK:Timage = LoadImage("gfx/0000.png")
Global G_TILE:Timage = LoadAnimImage("gfx/0001.png",36,32,0,64)
Global G_MAUS:Timage = LoadAnimImage("gfx/0002.png",48,32,0,3)
Global G_STRT:Timage = LoadImage("gfx/0003.png")
Global G_WINR:Timage = LoadAnimImage("gfx/0004.png",640,240,0,2)


Global G_CPURECOLOR:Int[24,24]
Global G_CPUMAP:Int[24,24]

Global G_RECOLOR:Int[24,24]
Global G_MAP:Int[24 , 14]
Global G_CHECK:Int[24 , 14]

Global GAMESTATUS = 0

Repeat

	If GAMESTATUS = 0
	
		DrawImage G_STRT,0,0
		DrawImage G_MAUS , MouseX() , MouseY() , 0

		mh = MouseHit(1) 
		If mh
			If MouseY() > 460 And MouseX() > 500 
				GAMESTATUS = 1		
				INIT_LEVEL()		
			EndIf
			If MouseY() > 460 And MouseX() < 215 
				GAMESTATUS = 3 'vs CPU
				INIT_LEVEL()		
			EndIf
		EndIf
		
			
	ElseIf GAMESTATUS = 1

		mh = MouseHit(1) 
		If mh
			If MouseX() > 212 And MouseX() < 428 And MouseY() > 12 And MouseY() < 44
				c= 1+(MouseX()-212)/36
			EndIf
			If c > 0 And G_MAP[1 , 1] <> c And G_MAP[21 , 12] <> c
				RECOLOR(ACTIVE_PLAYER , c) 
				If ACTIVE_PLAYER = 1
					ACTIVE_PLAYER = 2
				Else
					ACTIVE_PLAYER = 1
				EndIf
			EndIf
		
			If MouseY() > 460 And MouseX() < 100 INIT_LEVEL()		
			If MouseY() > 460 And MouseX() > 535 GAMESTATUS = 0
		
		EndIf
		
		DRAW_GAME() 
	
	ElseIf GAMESTATUS = 2
	
		DRAW_GAME() 
		If PLAYER1_STONES > 115
			DrawImage G_WINR , 0 , 130 , 0
		Else
			DrawImage G_WINR , 0 , 130 , 1
		EndIf
		DrawImage G_MAUS , MouseX() , MouseY() , 0

		mh = MouseHit(1) 
		If mh
			GAMESTATUS = 0		
		EndIf

	ElseIf GAMESTATUS = 3

		mh = MouseHit(1) 
		If mh And ACTIVE_PLAYER = 1
			If MouseX() > 212 And MouseX() < 428 And MouseY() > 12 And MouseY() < 44
				c= 1+(MouseX()-212)/36
			EndIf
			If c > 0 And G_MAP[1 , 1] <> c And G_MAP[21 , 12] <> c
				RECOLOR(1 , c) 
				ACTIVE_PLAYER = 4
			EndIf
			If MouseY() > 460 And MouseX() < 100 INIT_LEVEL()		
			If MouseY() > 460 And MouseX() > 535 GAMESTATUS = 0
		ElseIf ACTIVE_PLAYER = 2
			RECOLOR(2 , CPU_THINK()) 
			ACTIVE_PLAYER = 3
		EndIf
		
		If ACTIVE_PLAYER = 3 ACTIVE_PLAYER = 1
		If ACTIVE_PLAYER = 4 ACTIVE_PLAYER = 2		
		
		DRAW_GAME()
			
	EndIf	

Flip
	
Until KeyHit(KEY_ESCAPE)
End

Function CPU_THINK()

	best_c = 1
	best_s = 0
	
	For z = 1 To 6

		'sichern
		For y = 0 To 13
			For x = 0 To 23
				G_CPURECOLOR[x,y]=G_RECOLOR[x,y]
				G_CPUMAP[x,y]=G_MAP[x,y]
			Next	
		Next

		If z <> G_MAP[1 , 1] And z <> G_MAP[21 , 12] 'nur wenn KEINE gesperrte farben
		
			RECOLOR(2 , z) 
			COUNT_STONES()
			
			If PLAYER2_STONES > best_s
				best_s = PLAYER2_STONES
				best_c = z
			EndIf
			
		EndIf	

		'restore
		For y = 0 To 13
			For x = 0 To 23
				G_RECOLOR[x,y]=G_CPURECOLOR[x,y]
				G_MAP[x,y]=G_CPUMAP[x,y]
			Next	
		Next

	Next

	Return best_c
EndFunction

Function RECOLOR(p,c)

	'einfrben der bereits besetzten steine
	For y = 0 To 13
		For x = 0 To 23
			If G_RECOLOR[x , y] = p
				G_MAP[x , y] = c
			EndIf
		Next
	Next

	'besetzen aller angrenzenden steine mit der gleichen farbe

	Repeat
		
		z = 0
	
  	'ungerade spalten
		For y = 1 To 12
			For x = 1 To 22
				If G_MAP[x,y]=c And G_RECOLOR[x,y]=0
					If G_RECOLOR[x , y + 1] = p Or G_RECOLOR[x , y - 1] = p Or G_RECOLOR[x-1 , y - 1] = p Or G_RECOLOR[x-1 , y] = p Or G_RECOLOR[x+1 , y - 1] = p Or G_RECOLOR[x +1 , y ] = p 	
						G_RECOLOR[x,y] = p
						z=1
					EndIf
				EndIf
				x = x + 1
			Next
		Next
		
		'gerade spalten
		For y = 1 To 12
			For x = 2 To 22
				If G_MAP[x,y]=c And G_RECOLOR[x,y]=0
					If G_RECOLOR[x , y + 1] = p Or G_RECOLOR[x , y - 1] = p Or G_RECOLOR[x-1 , y + 1] = p Or G_RECOLOR[x-1 , y] = p Or G_RECOLOR[x+1 , y + 1] = p Or G_RECOLOR[x +1 , y ] = p 	
						G_RECOLOR[x,y] = p
						z=1
					EndIf
				EndIf
				x = x + 1
			Next
		Next
	
	Until z = 0

	'player wechseln

EndFunction

Function COUNT_STONES()
	
	PLAYER1_STONES = 0
	PLAYER2_STONES = 0

	For y = 0 To 13
		For x = 0 To 23
			If G_RECOLOR[x , y] = 1 PLAYER1_STONES = PLAYER1_STONES + 1
			If G_RECOLOR[x , y] = 2 PLAYER2_STONES = PLAYER2_STONES + 1
		Next	
	Next

	If PLAYER1_STONES > 115 Or PLAYER2_STONES > 115
		GAMESTATUS = 2
	EndIf
	
EndFunction

Function INIT_LEVEL()

	RestoreData DATA
	For y = 0 To 13
		For x = 0 To 23
			ReadData TILE
			G_CHECK[x,y]=TILE
			G_RECOLOR[x,y]=0
			If TILE	> 0	G_MAP[x , y] = Rand(1 , 6)
		Next	
	Next
	
	G_RECOLOR[1 , 1] = 1
	G_RECOLOR[21 ,12 ] = 2
	
	ACTIVE_PLAYER = Rand(1 , 2) 
	
EndFunction

Function DRAW_GAME() 

	DrawImage G_BACK , 0 , 0
	
	If G_MAP[1 , 1] <> 1 And G_MAP[21 , 12] <> 1 DrawImage G_TILE, 212,12,49
	If G_MAP[1 , 1] <> 2 And G_MAP[21 , 12] <> 2 DrawImage G_TILE, 248,12,50
	If G_MAP[1 , 1] <> 3 And G_MAP[21 , 12] <> 3 DrawImage G_TILE, 284,12,51
	If G_MAP[1 , 1] <> 4 And G_MAP[21 , 12] <> 4 DrawImage G_TILE, 320,12,52
	If G_MAP[1 , 1] <> 5 And G_MAP[21 , 12] <> 5 DrawImage G_TILE, 356,12,53
	If G_MAP[1 , 1] <> 6 And G_MAP[21 , 12] <> 6 DrawImage G_TILE, 392,12,54

	For y = 1 To 12
		For x = 1 To 22
			DrawImage G_TILE , 22 + (x - 1) * 28 , 68 + (y - 1) * 32 , G_MAP[x , y]+G_RECOLOR[x , y]*16
			x=x+1
		Next
	Next
	
	For y = 1 To 12
		For x = 2 To 23
			DrawImage G_TILE , 50 + (x - 2) * 28 , 84 + (y - 1) * 32 , G_MAP[x , y]+G_RECOLOR[x , y]*16
			x=x+1
		Next
	Next
	
	COUNT_STONES() 
	
	SetColor( 0 , 255 , 0 ) 
	DrawRect(52 , 19 , 0.413 * PLAYER1_STONES*3 , 18) 
	DrawRect(588- 0.413 * PLAYER2_STONES*3, 19 , 0.413 * PLAYER2_STONES*3 , 18) 
	SetColor( 255, 255, 255 )
	
	DrawImage G_MAUS , MouseX() , MouseY() , ACTIVE_PLAYER
		
	EndFunction


#DATA

	DefData 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DefData 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
	DefData 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
	DefData 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
	DefData 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
	DefData 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
	DefData 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
	DefData 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
	DefData 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
	DefData 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
	DefData 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
	DefData 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0
	DefData 0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,0
	DefData 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0


